#!/usr/bin/env ruby
# (c) 2007 camico A7 users.sourceforge.net
# License: GNU General Public License V2

video_player = "mplayer"

video_files = [
  "3gp",
  "asf",
  "avi",
  "flv",
  "m4v",
  "mkv",
  "mov",
  "mp4",
  "mpg",
  "ogm",
  ".rm",
  "vob",
  "wmv"
]

amarok = "dcop amarok player"
current_url = ""
is_local = false
vol = `#{amarok} getVolume`

loop do
    url = `#{amarok} encodedURL`.strip
    if url[0...4] == "file"
      is_local = true
      url = `#{amarok} path`.strip
    else
      is_local = false
    end

    if url != current_url
      current_vol = `#{amarok} getVolume`
      `#{amarok} setVolume #{vol}` if current_vol == "0\n" and vol != current_vol

      pid = `ps | awk '/#{video_player}/ {print $1}'`.split[0]
      `kill #{pid}` if pid
      
      filetype = url[-3..-1]
      if filetype and video_files.include? filetype.downcase
        if is_local
          vol = `#{amarok} getVolume`
          `#{amarok} setVolume 0`
          `#{amarok} pause`
          Thread.new{ `#{video_player} "#{url}" >/dev/null 2>&1 &` }
          # resume playing after 5 seconds to catch up with video player
          Thread.new{ sleep 5; `#{amarok} play` if `#{amarok} status` == "1\n" }
        else
          `#{amarok} pause`
          Thread.new{ `#{video_player} "#{url}" >/dev/null 2>&1 &` }
        end
      end    
      
      current_url = url
    end

    sleep 2
end

